OGRE-Next: Ogre::v1::VertexAnimationTrack Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::v1::VertexAnimationTrack Class Reference
Core » Animation

Specialised AnimationTrack for dealing with changing vertex position information. More...

`#include <OgreAnimationTrack.h>`

Inheritance diagram for Ogre::v1::VertexAnimationTrack:
[legend]

## Public Types
enum | TargetMode { TM_SOFTWARE , TM_HARDWARE }
| The target animation mode. More...

## Public Member Functions
| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType)
| Constructor.
| VertexAnimationTrack (Animation *parent, unsigned short handle, VertexAnimationType animType, VertexData *targetData, TargetMode target=TM_SOFTWARE)
| Constructor, associates with target VertexData and temp buffer (for software)
void | _applyBaseKeyFrame (const KeyFrame *base) override
| Internal method to re-base the keyframes relative to a given keyframe.
VertexAnimationTrack * | _clone (Animation *newParent) const
| Clone this track (internal use only)
void | apply (const TimeIndex &timeIndex, Real weight=1.0, Real scale=1.0f) override
| Applies an animation track to the designated target.
virtual void | applyToVertexData (VertexData *data, const TimeIndex &timeIndex, Real weight=1.0, const PoseList *poseList=0)
| As the 'apply' method but applies to specified VertexData instead of associated data.
virtual VertexMorphKeyFrame * | createVertexMorphKeyFrame (Real timePos)
| Creates a new morph KeyFrame and adds it to this animation at the given time index.
virtual VertexPoseKeyFrame * | createVertexPoseKeyFrame (Real timePos)
| Creates the single pose KeyFrame and adds it to this animation.
VertexAnimationType | getAnimationType () const
| Get the type of vertex animation we're performing.
VertexData * | getAssociatedVertexData () const
| Gets the associated VertexData which this track will update.
void | getInterpolatedKeyFrame (const TimeIndex &timeIndex, KeyFrame *kf) const override
| Gets a KeyFrame object which contains the interpolated transforms at the time index specified.
TargetMode | getTargetMode () const
| Get the target mode.
bool | getVertexAnimationIncludesNormals () const
| Whether the vertex animation (if present) includes normals.
VertexMorphKeyFrame * | getVertexMorphKeyFrame (unsigned short index) const
| Returns the morph KeyFrame at the specified index.
VertexPoseKeyFrame * | getVertexPoseKeyFrame (unsigned short index) const
| Returns the pose KeyFrame at the specified index.
bool | hasNonZeroKeyFrames () const override
| Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.
void | optimise () override
| Optimise the current track by removing any duplicate keyframes.
void | setAssociatedVertexData (VertexData *data)
| Sets the associated VertexData which this track will update.
void | setTargetMode (TargetMode m)
| Set the target mode.
Public Member Functions inherited from Ogre::v1::AnimationTrack
| AnimationTrack (Animation *parent, unsigned short handle)
| Constructor.
virtual | ~AnimationTrack ()
virtual void | _buildKeyFrameIndexMap (const vector< Real >::type &keyFrameTimes)
| Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.
virtual void | _collectKeyFrameTimes (vector< Real >::type &keyFrameTimes)
| Internal method to collect keyframe times, in unique, ordered format.
virtual void | _keyFrameDataChanged () const
| Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.
virtual KeyFrame * | createKeyFrame (Real timePos)
| Creates a new KeyFrame and adds it to this animation at the given time index.
unsigned short | getHandle () const
| Get the handle associated with this track.
virtual KeyFrame * | getKeyFrame (unsigned short index) const
| Returns the KeyFrame at the specified index.
virtual Real | getKeyFramesAtTime (const TimeIndex &timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const
| Gets the 2 KeyFrame objects which are active at the time given, and the blend value between them.
virtual unsigned short | getNumKeyFrames () const
| Returns the number of keyframes in this animation.
Animation * | getParent () const
| Returns the parent Animation object for this track.
virtual void | removeAllKeyFrames ()
| Removes all the KeyFrames from this track.
virtual void | removeKeyFrame (unsigned short index)
| Removes a KeyFrame by it's index.
virtual void | setListener (Listener *l)
| Set a listener for this track.

## Detailed Description

Specialised AnimationTrack for dealing with changing vertex position information.

See also
  VertexAnimationType

## Member Enumeration Documentation

## ◆ TargetMode

enum Ogre::v1::VertexAnimationTrack::TargetMode

The target animation mode.

Enumerator
TM_SOFTWARE | Interpolate vertex positions in software.
TM_HARDWARE | Bind keyframe 1 to position, and keyframe 2 to a texture coordinate for interpolation in hardware.

## Constructor & Destructor Documentation

## ◆ VertexAnimationTrack() [1/2]

Ogre::v1::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType )

Constructor.

Referenced by _clone().

## ◆ VertexAnimationTrack() [2/2]

Ogre::v1::VertexAnimationTrack::VertexAnimationTrack | ( | Animation * | parent,
|  | unsigned short | handle,
|  | VertexAnimationType | animType,
|  | VertexData * | targetData,
|  | TargetMode | target = TM_SOFTWARE )

Constructor, associates with target VertexData and temp buffer (for software)

References TM_SOFTWARE.

## Member Function Documentation

## ◆ _applyBaseKeyFrame()

void Ogre::v1::VertexAnimationTrack::_applyBaseKeyFrame | ( | const KeyFrame * | base | ) |
| overridevirtual

Internal method to re-base the keyframes relative to a given keyframe.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ _clone()

VertexAnimationTrack * Ogre::v1::VertexAnimationTrack::_clone | ( | Animation * | newParent | ) | const

Clone this track (internal use only)

References VertexAnimationTrack().

## ◆ apply()

void Ogre::v1::VertexAnimationTrack::apply | ( | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | Real | scale = 1.0f )
| overridevirtual

Applies an animation track to the designated target.

Parameters

  timeIndex | The time position in the animation to apply.
  weight | The influence to give to this track, 1.0 for full influence, less to blend with other animations.
  scale | The scale to apply to translations and scalings, useful for adapting an animation to a different size target.

Implements Ogre::v1::AnimationTrack.

## ◆ applyToVertexData()

virtual void Ogre::v1::VertexAnimationTrack::applyToVertexData | ( | VertexData * | data,
|  | const TimeIndex & | timeIndex,
|  | Real | weight = 1.0,
|  | const PoseList * | poseList = 0 )
| virtual

As the 'apply' method but applies to specified VertexData instead of associated data.

## ◆ createVertexMorphKeyFrame()

virtual VertexMorphKeyFrame * Ogre::v1::VertexAnimationTrack::createVertexMorphKeyFrame | ( | Real | timePos | ) |
| virtual

Creates a new morph KeyFrame and adds it to this animation at the given time index.

Remarks
  It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a KeyFrame at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0);

Parameters

  timePos | The time from which this KeyFrame will apply.

## ◆ createVertexPoseKeyFrame()

virtual VertexPoseKeyFrame * Ogre::v1::VertexAnimationTrack::createVertexPoseKeyFrame | ( | Real | timePos | ) |
| virtual

Creates the single pose KeyFrame and adds it to this animation.

## ◆ getAnimationType()

VertexAnimationType Ogre::v1::VertexAnimationTrack::getAnimationType | ( |  | ) | const
| inline

Get the type of vertex animation we're performing.

Referenced by Ogre::VerticesRemapInfo::performAnimationTrackRemap().

## ◆ getAssociatedVertexData()

VertexData * Ogre::v1::VertexAnimationTrack::getAssociatedVertexData | ( |  | ) | const
| inline

Gets the associated VertexData which this track will update.

## ◆ getInterpolatedKeyFrame()

void Ogre::v1::VertexAnimationTrack::getInterpolatedKeyFrame | ( | const TimeIndex & | timeIndex,
|  | KeyFrame * | kf ) const
| overridevirtual

Gets a KeyFrame object which contains the interpolated transforms at the time index specified.

Remarks
  The KeyFrame objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'.

Parameters

  timeIndex | The time (in relation to the whole animation sequence)
  kf | Keyframe object to store results

Implements Ogre::v1::AnimationTrack.

## ◆ getTargetMode()

TargetMode Ogre::v1::VertexAnimationTrack::getTargetMode | ( |  | ) | const
| inline

Get the target mode.

## ◆ getVertexAnimationIncludesNormals()

bool Ogre::v1::VertexAnimationTrack::getVertexAnimationIncludesNormals | ( |  | ) | const

Whether the vertex animation (if present) includes normals.

## ◆ getVertexMorphKeyFrame()

VertexMorphKeyFrame * Ogre::v1::VertexAnimationTrack::getVertexMorphKeyFrame | ( | unsigned short | index | ) | const

Returns the morph KeyFrame at the specified index.

Referenced by Ogre::VerticesRemapInfo::performAnimationTrackRemap().

## ◆ getVertexPoseKeyFrame()

VertexPoseKeyFrame * Ogre::v1::VertexAnimationTrack::getVertexPoseKeyFrame | ( | unsigned short | index | ) | const

Returns the pose KeyFrame at the specified index.

## ◆ hasNonZeroKeyFrames()

bool Ogre::v1::VertexAnimationTrack::hasNonZeroKeyFrames | ( |  | ) | const
| overridevirtual

Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ optimise()

void Ogre::v1::VertexAnimationTrack::optimise | ( |  | ) |
| overridevirtual

Optimise the current track by removing any duplicate keyframes.

Reimplemented from Ogre::v1::AnimationTrack.

## ◆ setAssociatedVertexData()

void Ogre::v1::VertexAnimationTrack::setAssociatedVertexData | ( | VertexData * | data | ) |
| inline

Sets the associated VertexData which this track will update.

## ◆ setTargetMode()

void Ogre::v1::VertexAnimationTrack::setTargetMode | ( | TargetMode | m | ) |
| inline

Set the target mode.

The documentation for this class was generated from the following file:

- OgreAnimationTrack.h